unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ForParse, AtConst;

type
  TfmDemo = class(TForm)
    Label1: TLabel;
    sbParse: TSpeedButton;
    lbError: TLabel;
    lb: TListBox;
    BitBtn1: TBitBtn;
    cbFormula: TComboBox;
    procedure sbParseClick(Sender: TObject);
  private
    { Private declarations }
  public
    function CalcMolMass(EL_NO: TEL_NOS; EL_QTY: TEL_QTY; NumOfElts, IonCharge: ShortInt) : double;
    { Public declarations }
  end;

var
  fmDemo: TfmDemo;

implementation

{$R *.DFM}

function TfmDemo.CalcMolMass(EL_NO: TEL_NOS; EL_QTY: TEL_QTY; NumOfElts, IonCharge: ShortInt) : double;
var i : integer;
begin
  Result := 0;
  for i := 1 to NumOfElts do
    Result := Result + AtomicData[EL_NO[i]].Atomic_Mass * EL_QTY[i];
  Result := Result - IonCharge * AtomicData[104].Atomic_Mass;  // e(-g)
end;

procedure TfmDemo.sbParseClick(Sender: TObject);
var in_st: string;
    EL_NO: TEL_NOS;
    EL_QTY: TEL_QTY;
    NumOfElts: ShortInt;
    PhStateCode: byte;
    IonCharge: ShortInt;
    Error: string;
    i: integer;
begin
  in_st := Trim(cbFormula.Text);
  if in_st < ' ' then Exit;
  lbError.Visible := False;
  lb.Items.Clear;
  PaF(in_st, EL_NO, EL_QTY, NumOfElts, PhStateCode, IonCharge, Error);
  if Error > ' ' then
    begin
    lbError.Caption := Error;
    lbError.Visible := True;
    Exit;
    end;

  with lb.Items do
    begin
    Add('NumOfElts = '+IntToStr(NumOfElts));
    Add('IonCharge = '+IntToStr(IonCharge));
    Add('');
    for i := 1 to NumOfElts do
      Add(AtomicData[EL_NO[i]].Formula+'  '+FloatToStr(EL_QTY[i]));
    Add('');
    Add('Mol. mass: '+FloatToStr(CalcMolMass(EL_NO, EL_QTY, NumOfElts, IonCharge)));
    end;
end;

end.
